/*---------------------------------------------------------------------------*\

    FILE....: vtcore.h
    TYPE....: C Function Header File
    AUTHOR..: Ben Kramer
    DATE....: 01/12/2005


\*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*\

         Voicetronix Voice Processing Board (VPB) Software

         Copyright (C) 1999-2004 Voicetronix www.voicetronix.com.au

         This library is free software; you can redistribute it and/or
         modify it under the terms of the GNU Lesser General Public
         License as published by the Free Software Foundation; either
         version 2.1 of the License, or (at your option) any later version.

         This library is distributed in the hope that it will be useful,
         but WITHOUT ANY WARRANTY; without even the implied warranty of
         MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
         Lesser General Public License for more details.

         You should have received a copy of the GNU Lesser General Public
         License along with this library; if not, write to the Free Software
         Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
         MA  02110-1301  USA

\*---------------------------------------------------------------------------*/

#ifndef __VTCORE_H__
#define __VTCORE_H__
#include "vpbreg.h"
#include "generic.h"

struct vtcore_chan {
	pid_t pid;
	int state;
	int run;
	int interface;		// FXO/FXS
	int encoding;		// Encoding
	int hand_num;		// handle number
	int chan_num;		// vpb channel number
	void *dtmf_dec;		// Pointer to dtmf states
	void *vox_states;	// Pointer to VOX detection states
	void *agc_states;	// Pointer to AGC states
	VPBREG *v;
};

/*-------------------------------------------------------------------------*\

			    FUNCTION HEADERS

\*-------------------------------------------------------------------------*/

class VTCore
{
private:
	void vtcoreHostDSPOpen();
	void vtcoreHostDSPClose();

public:
	VPBREG	*vr;
	int	finish;
	int	active_threads;
	void	**dtmf_dec;
	void	**toneg; 

	GENERIC_CRITICAL_SECTION mutex;

	VTCore(VPBREG *vr);
	~VTCore();

	int chan_state(int ch);
	int chan_type(int ch);
};


#endif
